using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

using gudusoft.gsqlparser;
using gudusoft.gsqlparser.Units;

namespace multithread
{
    
    public class parseJob
    {
        public int repetitions = 1;
        public void runme()
        {
            int c = Environment.TickCount;

            TGSqlParser sqlparser = new TGSqlParser(TDbVendor.DbVMssql);
            sqlparser.SqlText.Text = @"select last_name,job_id
                from employee
                order by hire_date";

            for (int i = 0; i < repetitions; i++)
            {
                int iRet = sqlparser.Parse();
            }

            Console.WriteLine("Parse {2} sqls in thread {1}: {0} seconds", String.Format("{0:0.00}", (Environment.TickCount - c) / 1000), Thread.CurrentThread.Name, repetitions);
        }
    }

    class multithread
    {
        static void Main(string[] args)
        {
            double c = Environment.TickCount;
            
            TGSqlParser sqlparser = new TGSqlParser(TDbVendor.DbVMssql);
            Console.WriteLine("Main thread, load sql parser: {0} seconds\n", String.Format("{0:0.00}", (Environment.TickCount - c) / 1000));

            sqlparser.SqlText.Text = @"select last_name,job_id
                    from employee
                    order by hire_date";

            Console.WriteLine("Main thread: parsing {0} sqls ...", 50000);

            for (int k = 0; k < 50000; k++)
            {
                int iRet = sqlparser.Parse();
            }

            Console.WriteLine("Main thread: In {0} seconds, {1} sql/second.\n",
                String.Format("{0:0.00}", (Environment.TickCount - c) / 1000),
                String.Format("{0:0.00}", (50000 / ((Environment.TickCount - c) / 1000))));


            Console.WriteLine("Multi thread mode:");
            c = Environment.TickCount;

            parseJob parseJob1 = new parseJob();
            parseJob1.repetitions = 10000;
            Thread thread1 = new Thread(new ThreadStart(parseJob1.runme));
            thread1.Name = "1";
            thread1.Start();

            parseJob parseJob2 = new parseJob();
            parseJob2.repetitions = 10000;
            Thread thread2 = new Thread(new ThreadStart(parseJob2.runme));
            thread2.Name = "2";
            thread2.Start();

            parseJob parseJob3 = new parseJob();
            parseJob3.repetitions = 10000;
            Thread thread3 = new Thread(new ThreadStart(parseJob3.runme));
            thread3.Name = "3";
            thread3.Start();

            parseJob parseJob4 = new parseJob();
            parseJob4.repetitions = 10000;
            Thread thread4 = new Thread(new ThreadStart(parseJob4.runme));
            thread4.Name = "4";
            thread4.Start();

            parseJob parseJob5 = new parseJob();
            parseJob5.repetitions = 10000;
            Thread thread5 = new Thread(new ThreadStart(parseJob5.runme));
            thread5.Name = "5";
            thread5.Start();

            thread1.Join();
            thread2.Join();
            thread3.Join();
            thread4.Join();
            thread5.Join();

            Console.WriteLine("Main thread: parsing {0} sql in {1} seconds, {2} sql/second.", 
                50000, 
                String.Format("{0:0.00}",(Environment.TickCount - c) / 1000), 
                String.Format("{0:0.00}",(50000 / ((Environment.TickCount - c)/1000))));
        }
    }
}
